# Aquesta classe mesura el CO2 amb el sensor MH-Z19B 
class Mhz19b:

    # inicialitza una nova instància 
    def __init__(self,rx_pin, tx_pin):
        self.uart = UART(1, baudrate=9600, bits=8, parity=None, stop=1, rx=int(rx_pin) ,tx=int(tx_pin))
        

    # mesura CO2
    def measure(self):
        while True:
            # enviem una ordre de lectura al sensor 
            self.uart.write(b'\xff\x01\x86\x00\x00\x00\x00\x00\x79')

            # una mica de temps per deixar que el sensor mesure CO2 i reenvie les dades 
            time.sleep(1)  # en segons

            # llegeix i valida les dades
            buf = self.uart.read(9)
            if self.is_valid(buf):
                break

            # Torneu-ho a provar si les dades són incorrectes 
            print('error while reading MH-Z19B sensor: invalid data')
            print('retry ...')

        
        # fes aquesta operació
        co2 = buf[2] * 256 + buf[3]
        return [co2]

    #  comproveu les dades retornades pel sensor 
    def is_valid(self, buf):
        if buf is None or buf[0] != 0xFF or buf[1] != 0x86:
            return False
        i = 1
        checksum = 0x00
        while i < 8:
            checksum += buf[i] % 256
            i += 1
        checksum = ~checksum & 0xFF
        checksum += 1
        return checksum == buf[8]

# Ací comença el programa
import machine
import time
from machine import Pin 
from machine import UART
from time import sleep_ms

SensorCO2 = Mhz19b(16, 17) # rx_pin= 16 i tx_pin= 17

for x in range(1, 100):
    print("Iteració = " , x) # Iteració x 
    # sumem la llista de 1 membre i la convertim a número enter
    lectura = int(sum(SensorCO2.measure())) 
    print("Lectura =", lectura)
    print(" ") # Espai en blanc 
    sleep_ms(500)
